﻿hunger = {};
hunger.realLifeDir = g_currentModDirectory;

function hunger.prerequisitesPresent(specializations)
    return true;
end;

function hunger:loadMap(name)
	self.foodListDef = 0.5;
	self.foodCount = g_i18n:getText("foodCount");
	self.foodListTextFontSize = 0.018;
	self.foodListTextSpace = 0.025;
	self.realLifeFile = g_modsDirectory.."/realLifeConfig.xml";
	self.reloadTime = 0;
	self.foodMenuStatus = false;
	self.switcherCursor = false;
	self.noHungerTime = 0;
	self.renderWarTime = 0;
	self.saveHungerTime = 60;
	self.colorBlack = {0.094, 0.086, 0.082};
	self.colorBlue = {0.302, 0.69, 0.851};
	self.closeActive = false;
	self.backPackFullTime = 0;
	self.backPackStatus = false;
	self.switcherCursorPack = false;

	self.mapPosX = g_currentMission.ingameMap.mapPosX;
	self.mapPosY = g_currentMission.ingameMap.mapPosY;
	self.mapHeight = g_currentMission.ingameMap.minMapHeight;
	self.mapWidth = g_currentMission.ingameMap.minMapWidth;
	self.foodListWidth = self.mapWidth*2;
	self.foodListHeight = self.foodListWidth/16*getScreenAspectRatio();

	self.foodListBlack = createImageOverlay(Utils.getFilename("textures/black.dds", hunger.realLifeDir));
	self.foodListBlue = createImageOverlay(Utils.getFilename("textures/blue.dds", hunger.realLifeDir));
	self.hungerFrame = createImageOverlay(Utils.getFilename("textures/hungerFrame.dds", hunger.realLifeDir));
	self.closeWhite = createImageOverlay(Utils.getFilename("textures/closeWhite.dds", hunger.realLifeDir));
	self.closeBlue = createImageOverlay(Utils.getFilename("textures/closeBlue.dds", hunger.realLifeDir));
	self.arrowDownWhite = createImageOverlay(Utils.getFilename("textures/arrowDownWhite.dds", hunger.realLifeDir));
	self.arrowDownBlue = createImageOverlay(Utils.getFilename("textures/arrowDownBlue.dds", hunger.realLifeDir));

	hunger:loadRealLife();
	hunger:foodListPrg();
end;

function hunger:deleteMap()
end;

function hunger:mouseEvent(posX, posY, isDown, isUp, button)
	if self.foodMenuStatus then
		for i = 1, self.foodCount do
			if posX > self.foodListDef-self.foodListWidth*0.5 and posX < self.foodListDef+self.foodListWidth*0.5 and posY > self.foodListPrgY[i]-0.006 and posY < self.foodListPrgY[i]-0.006+self.foodListHeight then
				self.selectPrg = i;
				if isDown then
					if self.hungerValue > 1 then
						local energy = string.format("energy%d", i);
						self.tempHunger = g_i18n:getText(energy)*0.1;
						self.tempMoney = g_i18n:getText(energy)*1.5;
						g_currentMission:addSharedMoney(-self.tempMoney);
					else
						self.noHungerTime = 2;
					end;
				end;
			end;

			if posX > self.foodListDef+(self.foodListWidth*0.5)+0.005 and posX < (self.foodListDef+(self.foodListWidth*0.5)+0.005)+(self.foodListTextFontSize/getScreenAspectRatio()*1.35) and posY > self.foodListPrgY[i]-0.006 and posY < (self.foodListPrgY[i]-0.006)+(self.foodListTextFontSize*1.35) then
				self.selectArrowDown = i;
				if isDown then
					local foodBackpackPos;
					self.hungerConfig = loadXMLFile("realLifeConfig", self.realLifeFile, "realLife");
					if fileExists(self.realLifeFile) then
						for i = 1, 10 do
							foodBackpackPos = string.format("realLife.food%d", i);
							self.foodBackPos = getXMLInt(self.hungerConfig, foodBackpackPos);
							if self.foodBackPos == 0 then
								setXMLInt(self.hungerConfig, foodBackpackPos, self.selectArrowDown);
								saveXMLFile(self.hungerConfig);
								local energy = string.format("energy%d", self.selectArrowDown);
								self.tempMoney = g_i18n:getText(energy)*1.5;
								g_currentMission:addSharedMoney(-self.tempMoney);
								break;
							end;
							if i == 10 then
								self.backPackFullTime = 2;
							end;
						end;
					end;
				end;
			end;
		end;

		if posX > self.foodListDef+(self.foodListWidth*0.5)+0.005 and posX < (self.foodListDef+(self.foodListWidth*0.5)+0.005)+(self.foodListTextFontSize/getScreenAspectRatio()*1.35) and posY > self.foodListPosY-0.006 and posY < (self.foodListPosY-0.006)+(self.foodListTextFontSize*1.35) then
			self.closeActive = true;
			if isDown then
				self.foodMenuStatus = false;
			end;
		else
			self.closeActive = false;
		end;
	end;

	if self.backPackStatus then
		local energy;
		self.hungerConfig = loadXMLFile("realLifeConfig", self.realLifeFile, "realLife");
		if posX > self.foodListDef+(self.foodListWidth*0.5)+0.005 and posX < (self.foodListDef+(self.foodListWidth*0.5)+0.005)+(self.foodListTextFontSize/getScreenAspectRatio()*1.35) and posY > self.foodListPosY-0.006 and posY < (self.foodListPosY-0.006)+(self.foodListTextFontSize*1.35) then
			self.closeActive = true;
			if isDown then
				self.backPackStatus = false;
			end;
		else
			self.closeActive = false;
		end;

		for i = 1, 10 do
			if posX > self.foodListDef-self.foodListWidth*0.5 and posX < (self.foodListDef-self.foodListWidth*0.5)+(self.foodListWidth) and posY > self.foodListPrgY[i]-0.006 and posY < (self.foodListPrgY[i]-0.006)+(self.foodListTextFontSize*1.35) then
				self.selectPrg = i;
				if isDown then
					if self.hungerValue > 1 then
						inventoryPositionText = string.format("realLife.food%d", i);
						energy = string.format("energy%d", getXMLInt(self.hungerConfig, inventoryPositionText));
						self.tempHunger = g_i18n:getText(energy)*0.1;
						setXMLInt(self.hungerConfig, inventoryPositionText, 0);
						saveXMLFile(self.hungerConfig);
					else
						self.noHungerTime = 2;
					end;
				end;
			end;
		end;
	end;
end;

function hunger:keyEvent(unicode, sym, modifier, isDown)
end;

function hunger:update(dt)
	setTextColor(1, 1, 1, 1);
	setTextAlignment(RenderText.ALIGN_CENTER);

	hunger:hungerPlus(dt, 120);
	hunger:foodMenuActivate();
	hunger:foodList();
	hunger:hungerMinus(dt, 0.05);
	hunger:noHungerRender(dt);
	hunger:reloadFoodPointPos(dt);
	hunger:warTime(dt);
	hunger:saveHunger(dt);
	hunger:backPackActivate();
end;

function hunger:draw()
	setOverlayColor(self.foodListBlack, self.colorBlack[1], self.colorBlack[2], self.colorBlack[3], 0.9);
	setOverlayColor(self.hungerFrame, self.colorBlack[1], self.colorBlack[2], self.colorBlack[3], 0.9);
	setOverlayColor(self.foodListBlue, self.colorBlue[1], self.colorBlue[2], self.colorBlue[3], 0.9);

	if g_currentMission.showHudEnv then
		renderOverlay(self.foodListBlue, self.mapPosX, self.mapPosY+self.mapHeight+(self.mapWidth*getScreenAspectRatio()/8)*0.5, self.mapWidth/100*self.hungerValue, self.mapWidth*getScreenAspectRatio()/8);
		renderOverlay(self.hungerFrame, self.mapPosX, self.mapPosY+self.mapHeight+(self.mapWidth*getScreenAspectRatio()/8)*0.5, self.mapWidth, self.mapWidth*getScreenAspectRatio()/8);
	end;

	hunger:drawFoodMenu();
	hunger:renderOver();
end;

-----------------------------------------------------------
function hunger:loadRealLife()
	if fileExists(self.realLifeFile) then
		self.hungerConfig = loadXMLFile("realLifeConfig", self.realLifeFile, "realLife");
		self.hungerValue = Utils.getNoNil(getXMLFloat(self.hungerConfig, "realLife.hunger"), 0);
		self.foodPointX = string.format("%s", getXMLString(self.hungerConfig, "realLife.foodPointX"));
		self.foodPointY = string.format("%s", getXMLString(self.hungerConfig, "realLife.foodPointY"));
		self.foodPointZ = string.format("%s", getXMLString(self.hungerConfig, "realLife.foodPointZ"));
	else
		self.hungerConfig = createXMLFile("realLifeConfig", self.realLifeFile, "realLife");
		setXMLFloat(self.hungerConfig, "realLife.hunger", 0);
		setXMLString(self.hungerConfig, "realLife.foodPointX", "nil");
		setXMLString(self.hungerConfig, "realLife.foodPointY", "nil");
		setXMLString(self.hungerConfig, "realLife.foodPointZ", "nil");
		local foodBackPos;
		for i = 1, 10 do
			foodBackPos = string.format("realLife.food%d", i)
			setXMLInt(self.hungerConfig, foodBackPos, 0);
		end;
		saveXMLFile(self.hungerConfig);
		self.hungerConfig = loadXMLFile("realLifeConfig", self.realLifeFile, "realLife");
		self.hungerValue = Utils.getNoNil(getXMLFloat(self.hungerConfig, "realLife.hunger"), 0);
		self.foodPointX = string.format("%s", getXMLString(self.hungerConfig, "realLife.foodPointX"));
		self.foodPointY = string.format("%s", getXMLString(self.hungerConfig, "realLife.foodPointY"));
		self.foodPointZ = string.format("%s", getXMLString(self.hungerConfig, "realLife.foodPointZ"));
	end;
end;
-----------------------------------------------------------

-----------------------------------------------------------
function hunger:hungerPlus(tempDt, durationMimute)
	if self.hungerValue < 100 then
		self.hungerValue = self.hungerValue + (tempDt*0.001)*(100/(durationMimute*60));
	end;
end
-----------------------------------------------------------

-----------------------------------------------------------
function hunger:reloadFoodPointPos(tempDt)
	if self.reloadTime <= 0 then
		if fileExists(self.realLifeFile) then
			self.hungerConfig = loadXMLFile("realLifeConfig", self.realLifeFile, "realLife");
			self.foodPointX = string.format("%s", getXMLString(self.hungerConfig, "realLife.foodPointX"));
			self.foodPointY = string.format("%s", getXMLString(self.hungerConfig, "realLife.foodPointY"));
			self.foodPointZ = string.format("%s", getXMLString(self.hungerConfig, "realLife.foodPointZ"));
		end;
		self.reloadTime = 5;
	else
		self.reloadTime = self.reloadTime-tempDt*0.001;
	end;
end;
-----------------------------------------------------------

-----------------------------------------------------------
function hunger:foodMenuActivate()
	if self.foodPointX ~= "nil" and self.foodPointY ~= "nil" and self.foodPointZ ~= "nil" then
		self.playerPosX, self.playerPosY, self.playerPosZ = getWorldTranslation(g_currentMission.player.rootNode);
		self.distance = Utils.vector3Length(self.foodPointX - self.playerPosX, self.foodPointY - self.playerPosY, self.foodPointZ - self.playerPosZ);
		if self.distance < 2 then
			if self.foodMenuStatus then
				g_currentMission:addHelpButtonText(g_i18n:getText("foodMenuClose"), InputBinding.foodMenu);
				InputBinding.setShowMouseCursor(true);
				self.switcherCursor = true;
			else
				g_currentMission:addHelpButtonText(g_i18n:getText("foodMenuOpen"), InputBinding.foodMenu);
				InputBinding.setShowMouseCursor(false);
			end;
			if InputBinding.hasEvent(InputBinding.foodMenu) then
				self.foodMenuStatus = not self.foodMenuStatus;
			end;
		else
			self.foodMenuStatus = false;
			if self.switcherCursor then
				InputBinding.setShowMouseCursor(false);
				self.switcherCursor = false;
			end;

			if self.backPackStatus then
				g_currentMission:addHelpButtonText(g_i18n:getText("backPackClose"), InputBinding.foodMenu);
			else
				g_currentMission:addHelpButtonText(g_i18n:getText("backPackOpen"), InputBinding.foodMenu);
			end;
			if InputBinding.hasEvent(InputBinding.foodMenu) then
				self.backPackStatus = not self.backPackStatus;
			end;
		end;
	end;
end;
-----------------------------------------------------------

-----------------------------------------------------------
function hunger:backPackActivate()
	if self.backPackStatus then
		local wordMenu = string.format("------------ %s ------------", g_i18n:getText("backPack"))
		renderText(self.foodListDef, self.foodListPosY, self.foodListTextFontSize, wordMenu);

		self.switcherCursorPack = true;
		InputBinding.setShowMouseCursor(true);

		local foodName;
		local inventoryPositionText;
		local energy;
		local foodList;
		self.hungerConfig = loadXMLFile("realLifeConfig", self.realLifeFile, "realLife");
	 	for i = 1, 10 do
	 		inventoryPositionText = string.format("realLife.food%d", i);
	 		foodName = string.format("food%d", getXMLInt(self.hungerConfig, inventoryPositionText));
	 		energy = string.format("energy%d", getXMLInt(self.hungerConfig, inventoryPositionText));
	 		if getXMLInt(self.hungerConfig, inventoryPositionText) ~= 0 then
	 			foodList = string.format("%s - [%d %s] - %d €", g_i18n:getText(foodName), g_i18n:getText(energy), g_i18n:getText("energyValue"), g_i18n:getText(energy)*1.5);
	 		else
	 			foodList = string.format("%s", g_i18n:getText("empty"));
	 		end;
	 		renderText(self.foodListDef, self.foodListPrgY[i], self.foodListTextFontSize, foodList);
	 	end;
	else
		if self.switcherCursorPack then
			InputBinding.setShowMouseCursor(false);
			self.switcherCursorPack = false;
		end;
	end;
end;
-----------------------------------------------------------

-----------------------------------------------------------
function hunger:foodListPrg()
	self.foodListPosY = self.foodListDef+((self.foodListTextFontSize*self.foodCount)+(self.foodListTextSpace*(self.foodCount-1)))*0.5;
	self.foodListPrgY = {};
	for i = 1, self.foodCount do
		table.insert(self.foodListPrgY, self.foodListPosY-self.foodListTextSpace*(i+0.5));
	end;
end;
-----------------------------------------------------------

-----------------------------------------------------------
function hunger:foodList()
	if self.foodMenuStatus then
		local wordMenu = string.format("------------ %s ------------", g_i18n:getText("foodMenu"))
		renderText(self.foodListDef, self.foodListPosY, self.foodListTextFontSize, wordMenu);

	 	for i = 1, self.foodCount do
	 		local foodName = string.format("food%d", i);
	 		local energy = string.format("energy%d", i);
	 		local foodList = string.format("%s - [%d %s] - %d €", g_i18n:getText(foodName), g_i18n:getText(energy), g_i18n:getText("energyValue"), g_i18n:getText(energy)*1.5);
	 		renderText(self.foodListDef, self.foodListPrgY[i], self.foodListTextFontSize, foodList);
	 	end;
	end;
end;

function hunger:drawFoodMenu()
	if self.foodMenuStatus then
		renderOverlay(self.foodListBlack, self.foodListDef-self.foodListWidth*0.5, self.foodListPosY-0.006, self.foodListWidth, self.foodListTextFontSize*1.35);
		renderOverlay(self.closeWhite, self.foodListDef+(self.foodListWidth*0.5)+0.005, self.foodListPosY-0.006, self.foodListTextFontSize/getScreenAspectRatio()*1.35, self.foodListTextFontSize*1.35);
		
		if self.closeActive then
			renderOverlay(self.closeBlue, self.foodListDef+(self.foodListWidth*0.5)+0.005, self.foodListPosY-0.006, self.foodListTextFontSize/getScreenAspectRatio()*1.35, self.foodListTextFontSize*1.35);
		end;
		for i = 1, self.foodCount do
			renderOverlay(self.foodListBlack, self.foodListDef-self.foodListWidth*0.5, self.foodListPrgY[i]-0.006, self.foodListWidth, self.foodListTextFontSize*1.35);
			renderOverlay(self.arrowDownWhite, self.foodListDef+(self.foodListWidth*0.5)+0.005, self.foodListPrgY[i]-0.006, self.foodListTextFontSize/getScreenAspectRatio()*1.35, self.foodListTextFontSize*1.35);
		end;
		if self.selectPrg ~= nil then
			renderOverlay(self.foodListBlue, self.foodListDef-self.foodListWidth*0.5, self.foodListPrgY[self.selectPrg]-0.006, self.foodListWidth, self.foodListTextFontSize*1.35);
		end;
		if self.selectArrowDown ~= nil then
			renderOverlay(self.arrowDownBlue, self.foodListDef+(self.foodListWidth*0.5)+0.005, self.foodListPrgY[self.selectArrowDown]-0.006, self.foodListTextFontSize/getScreenAspectRatio()*1.35, self.foodListTextFontSize*1.35);
		end;
		if self.noHungerTime > 0 or self.backPackFullTime > 0 then
			renderOverlay(self.foodListBlack, self.foodListDef-self.foodListWidth*0.5, self.foodListPrgY[self.foodCount-1]-(self.foodListTextFontSize*2+self.foodListTextSpace*1.5), self.foodListWidth, self.foodListTextFontSize*1.35);
		end;
	end;

	if self.backPackStatus then
		renderOverlay(self.foodListBlack, self.foodListDef-self.foodListWidth*0.5, self.foodListPosY-0.006, self.foodListWidth, self.foodListTextFontSize*1.35);
		renderOverlay(self.closeWhite, self.foodListDef+(self.foodListWidth*0.5)+0.005, self.foodListPosY-0.006, self.foodListTextFontSize/getScreenAspectRatio()*1.35, self.foodListTextFontSize*1.35);
		
		for i = 1, 10 do
			renderOverlay(self.foodListBlack, self.foodListDef-self.foodListWidth*0.5, self.foodListPrgY[i]-0.006, self.foodListWidth, self.foodListTextFontSize*1.35);
		end;
		if self.closeActive then
			renderOverlay(self.closeBlue, self.foodListDef+(self.foodListWidth*0.5)+0.005, self.foodListPosY-0.006, self.foodListTextFontSize/getScreenAspectRatio()*1.35, self.foodListTextFontSize*1.35);
		end;
		if self.selectPrg ~= nil then
			renderOverlay(self.foodListBlue, self.foodListDef-self.foodListWidth*0.5, self.foodListPrgY[self.selectPrg]-0.006, self.foodListWidth, self.foodListTextFontSize*1.35);
		end;
		if self.selectPrg ~= nil then
			renderOverlay(self.foodListBlue, self.foodListDef-self.foodListWidth*0.5, self.foodListPrgY[self.selectPrg]-0.006, self.foodListWidth, self.foodListTextFontSize*1.35);
		end;
		if self.noHungerTime > 0 then
			renderOverlay(self.foodListBlack, self.foodListDef-self.foodListWidth*0.5, self.foodListPrgY[self.foodCount-1]-(self.foodListTextFontSize*2+self.foodListTextSpace*1.5), self.foodListWidth, self.foodListTextFontSize*1.35);
		end;
	end;
end;
-----------------------------------------------------------

-----------------------------------------------------------
function hunger:hungerMinus(tempDt, tempMulti)
	if self.tempHunger ~= nil then
		if self.tempHunger > 0 then
			if self.hungerValue > 1 then
				self.hungerValue = self.hungerValue - tempDt*tempMulti;
				self.tempHunger = self.tempHunger - tempDt*tempMulti;
			else
				self.noHungerTime = 2;
				self.tempHunger = 0;
			end;
		end;
	end;
end;
-----------------------------------------------------------

-----------------------------------------------------------
function hunger:noHungerRender(tempDt)
	if self.foodMenuStatus or self.backPackStatus then
		if self.noHungerTime > 0 then
			renderText(self.foodListDef, (self.foodListPrgY[self.foodCount-1]-(self.foodListTextFontSize*2+self.foodListTextSpace*1.5))+0.006, self.foodListTextFontSize, g_i18n:getText("noHunger"));
			self.noHungerTime = self.noHungerTime - tempDt*0.001;
		end;

		if self.backPackFullTime > 0 then
			renderText(self.foodListDef, (self.foodListPrgY[self.foodCount-1]-(self.foodListTextFontSize*2+self.foodListTextSpace*1.5))+0.006, self.foodListTextFontSize, g_i18n:getText("backPackFull"));
			self.backPackFullTime = self.backPackFullTime - tempDt*0.001;
		end;
	end;
end;
-----------------------------------------------------------

-----------------------------------------------------------
function hunger:renderOver()
	if self.hungerValue > 95 and self.hungerValue <= 97 then
		if self.renderWarTime > 8 then
			setOverlayColor(self.foodListBlack, self.colorBlack[1], self.colorBlack[2], self.colorBlack[3], 0.5);
			renderOverlay(self.foodListBlack, 0, 0, 1, 1);
		end;
	elseif self.hungerValue > 97 and self.hungerValue <=99 then
		if self.renderWarTime > 5 then
			setOverlayColor(self.foodListBlack, self.colorBlack[1], self.colorBlack[2], self.colorBlack[3], 0.8);
			renderOverlay(self.foodListBlack, 0, 0, 1, 1);
		end;
	elseif self.hungerValue > 99 then
		setOverlayColor(self.foodListBlack, self.colorBlack[1], self.colorBlack[2], self.colorBlack[3], 0.9);
		renderOverlay(self.foodListBlack, 0, 0, 1, 1);
	end;
end;

function hunger:warTime(tempDt)
	if self.hungerValue > 95 then
		if self.renderWarTime > 0 then
			self.renderWarTime = self.renderWarTime-tempDt*0.001;
		else
		 	self.renderWarTime = 10;
		end;
	end;

	if self.hungerValue > 95 and self.hungerValue <= 97 then
		if self.renderWarTime > 8 then
			renderText(0.5, 0.5, 0.020, g_i18n:getText("hunger"));
		end;
	elseif self.hungerValue > 97 and self.hungerValue <= 99 then
		if self.renderWarTime > 5 then
			renderText(0.5, 0.5, 0.020, g_i18n:getText("hunger"));
		end;
	elseif self.hungerValue > 99 then
		renderText(0.5, 0.5, 0.020, g_i18n:getText("hunger"));
	end;
end;
-----------------------------------------------------------

-----------------------------------------------------------
function hunger:saveHunger(tempDt)
	if self.saveHungerTime > 0 then
		self.saveHungerTime = self.saveHungerTime - tempDt*0.001;
	else
		if fileExists(self.realLifeFile) then
			self.hungerConfig = loadXMLFile("realLifeConfig", self.realLifeFile, "realLife");
			setXMLFloat(self.hungerConfig, "realLife.hunger", self.hungerValue);
			saveXMLFile(self.hungerConfig);
		else
			self.hungerConfig = createXMLFile("realLifeConfig", self.realLifeFile, "realLife");
			setXMLFloat(self.hungerConfig, "realLife.hunger", self.hungerValue);
			saveXMLFile(self.hungerConfig);
		end;
		self.saveHungerTime = 60;
	end;
end;
-----------------------------------------------------------

addModEventListener(hunger);

--local testText = string.format("");
--renderText(0.5, 0.05, 0.012, testText);
--g_currentMission:addWarning(g_i18n:getText("hungerWarning"));
--g_currentMission:addExtraPrintText(fatigueText);
--g_currentMission:addHelpButtonText(g_i18n:getText("foodMenu"), InputBinding.foodMenu);
--InputBinding.hasEvent(InputBinding.VDRepair)